//  D88ėpt@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>

#include "d88.h"

using namespace std;

static unsigned char buffer[0x100*16*180];	// 傫͒K
static unsigned char id[4*64];				// 傫͒K

int val(char* _str)
{
	int v=0;
	if (sscanf(_str,"0x%x",&v)!=1)
	{
		sscanf(_str,"%d",&v);
	}
	return v;
}

int main(int argc, char *argv[])
{

	if (argc < 6) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] [outputfile] [diskno] [track] [Sector] (size) (offset)\n",argv[0]);
		fprintf(stderr, "       sizew莞1sector؂o܂.\n");
		return 1;
	}

	int diskno = val(argv[3]);
	int track  = val(argv[4]);
	int sector = val(argv[5]);
	int size;
	int secnum;
	int offset = 0;
	if (argc>7)	offset = val(argv[7]);

	D88 disk;
	FILE *fp;

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	if (numdisk < diskno+1)
	{
		fprintf(stderr, "w̃fBXN܂.\n");
		return 1;
	}
	disk.SelectDisk(diskno);

	secnum = disk.ReadID(track,id,sizeof(id))/4;	// IDSēǂݍ
	if (secnum==0)
	{
		fprintf(stderr, "w̃gbN̓tH[}bgĂ܂.\n");
		return 1;
	}
	// C^[[u (ZN^ԍɃ\[g)
	for (int s1 = 0; s1 < secnum-1; s1++)
	{
		for (int s2 = 0; s2 < (secnum-1); s2++)
		{
			if (id[s2*4+2] > id[(s2+1)*4+2])
			{
				swap (id[s2*4  ], id[(s2+1)*4  ]);
				swap (id[s2*4+1], id[(s2+1)*4+1]);
				swap (id[s2*4+2], id[(s2+1)*4+2]);
				swap (id[s2*4+3], id[(s2+1)*4+3]);
			}
		}
	}
	disk.SetRecordRange(id[2],id[(secnum-1)*4+2]);

	if (argc > 6) {
		size = val(argv[6]);
	} else {
		size = 0x100<<(id[3]-1);
	}

	if (!disk.ReadDATA(track, track>>1, track&1, sector, id[(sector-id[2])*4+3], buffer, size+offset))
	{
		fprintf(stderr, "w̃gbN/ZN^݂܂.\n");
		return 1;
	}
	printf ("diskno:%2d track:%2d sector:%2d size:%d offset:%d ؂o܂.\n",diskno,track,sector,size,offset);

	fp = fopen(argv[2], "wb");
	if (!fp) { 
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}
	fwrite(&buffer[offset], 1, size, fp);
	fclose(fp);
	if (ferror(fp)) { 
		fprintf(stderr, "t@C߂܂. \n");
		return 1;
	}
	return 0;
}

